searchNodes=[{"doc":"Neuron is a GraphQL client for elixir. Usage iex&gt; Neuron.Config . set ( url : &quot;https://example.com/graph&quot; ) iex&gt; Neuron . query ( &quot;&quot;&quot; { films { title } } &quot;&quot;&quot; ) # Response will be: { :ok , % Neuron.Response { body : %{ &quot;data&quot; =&gt; { &quot;films&quot; =&gt; [ %{ &quot;title&quot; =&gt; &quot;A New Hope&quot; } ] } } % , status_code : 200 , headers : [ ] } } # You can also run mutations iex&gt; Neuron . query ( &quot;&quot;&quot; mutation createUser($name: String!) { createUser(name: $name) { id name } } &quot;&quot;&quot; , %{ name : &quot;uesteibar&quot; } )","ref":"Neuron.html","title":"Neuron","type":"module"},{"doc":"runs a query request to your graphql endpoint. Example Neuron . query ( &quot;&quot;&quot; { films { count } } &quot;&quot;&quot; ) You can pass variables for your query Example Neuron . query ( &quot;&quot;&quot; mutation createUser($name: String!) { createUser(name: $name) { id name } } &quot;&quot;&quot; , %{ name : &quot;uesteibar&quot; } ) You can also overwrite parameters set on Neuron.Config by passing them as options. Example Neuron . query ( &quot;&quot;&quot; mutation createUser($name: String!) { createUser(name: $name) { id name } } &quot;&quot;&quot; , %{ name : &quot;uesteibar&quot; } , url : &quot;https://www.other.com/graphql&quot; )","ref":"Neuron.html#query/3","title":"Neuron.query/3","type":"function"},{"doc":"This module can be used to modify your graphql client configuration either globaly or for the current process.","ref":"Neuron.Config.html","title":"Neuron.Config","type":"module"},{"doc":"gets configuration value for Neuron Examples iex&gt; Neuron.Config . set ( url : &quot;http://example.com/graph&quot; ) iex&gt; Neuron.Config . get ( :url ) &quot;http://example.com/graph&quot; iex&gt; Neuron.Config . set ( headers : [ name : &quot;value&quot; ] ) iex&gt; Neuron.Config . get ( :headers ) [ name : &quot;value&quot; ] iex&gt; Neuron.Config . get ( :invalid ) nil","ref":"Neuron.Config.html#get/1","title":"Neuron.Config.get/1","type":"function"},{"doc":"sets global configuration values for Neuron Examples iex&gt; Neuron.Config . set ( url : &quot;http://example.com/graph&quot; ) :ok","ref":"Neuron.Config.html#set/1","title":"Neuron.Config.set/1","type":"function"},{"doc":"sets global/process configuration values for Neuron Available options are: url: graphql endpoint url headers: headers to be sent in the request connection_opts: additional options to be passed to connection library connection_module: module to be used for connecting to GQL API. Default is Neuron.Connection.Http json_library: JSON library. Default is Jason. parse_options: options to be passed to the JSON library when decoding JSON Examples iex&gt; Neuron.Config . set ( headers : [ name : &quot;val&quot; ] ) :ok iex&gt; Neuron.Config . set ( :process , url : &quot;http://example.com/graph&quot; ) :ok iex&gt; Neuron.Config . set ( json_library : Jason ) :ok iex&gt; Neuron.Config . set ( parse_options : [ keys : :atoms ] ) :ok","ref":"Neuron.Config.html#set/2","title":"Neuron.Config.set/2","type":"function"},{"doc":"This module provides helper functions to read config + options for Neuron.","ref":"Neuron.ConfigUtils.html","title":"Neuron.ConfigUtils","type":"module"},{"doc":"Returns the Connection module that is configured in Neuron. Default is Neuron.Connection.Http.","ref":"Neuron.ConfigUtils.html#connection_module/0","title":"Neuron.ConfigUtils.connection_module/0","type":"function"},{"doc":"Returns the Connection library that is configured in Neuron, or overriden in options. Default is Neuron.Connection.Http.","ref":"Neuron.ConfigUtils.html#connection_module/1","title":"Neuron.ConfigUtils.connection_module/1","type":"function"},{"doc":"Returns the connection options that is configured in Neuron, or overriden in options.","ref":"Neuron.ConfigUtils.html#connection_options/1","title":"Neuron.ConfigUtils.connection_options/1","type":"function"},{"doc":"Returns the JSON library that is configured in Neuron. Default is Jason.","ref":"Neuron.ConfigUtils.html#json_library/0","title":"Neuron.ConfigUtils.json_library/0","type":"function"},{"doc":"Returns the JSON library that is configured in Neuron, or overriden in options. Default is Jason.","ref":"Neuron.ConfigUtils.html#json_library/1","title":"Neuron.ConfigUtils.json_library/1","type":"function"},{"doc":"Returns the JSON parsing options that is configured in Neuron, or overriden in options.","ref":"Neuron.ConfigUtils.html#parse_options/1","title":"Neuron.ConfigUtils.parse_options/1","type":"function"},{"doc":"Neuron.Connection is a behaviour for defining pluggable connectors for Neuron library.","ref":"Neuron.Connection.html","title":"Neuron.Connection","type":"behaviour"},{"doc":"","ref":"Neuron.Connection.html#c:call/2","title":"Neuron.Connection.call/2","type":"callback"},{"doc":"This module can be used to register fragments to be used in your GraphQL queries","ref":"Neuron.Fragment.html","title":"Neuron.Fragment","type":"module"},{"doc":"registers a fragment that will automatically be added to future mutations and queries that require it Example iex&gt; Neuron.Fragment . register ( &quot; ...&gt; NameParts on Person { ...&gt; firstName ...&gt; lastName ...&gt; } ...&gt; &quot; ) :ok","ref":"Neuron.Fragment.html#register/1","title":"Neuron.Fragment.register/1","type":"function"},{"doc":"","ref":"Neuron.Fragment.html#register/2","title":"Neuron.Fragment.register/2","type":"function"},{"doc":"Struct representation of a JSON parse error.","ref":"Neuron.JSONParseError.html","title":"Neuron.JSONParseError","type":"module"},{"doc":"","ref":"Neuron.JSONParseError.html#t:t/0","title":"Neuron.JSONParseError.t/0","type":"type"},{"doc":"Struct representation of a query response.","ref":"Neuron.Response.html","title":"Neuron.Response","type":"module"},{"doc":"","ref":"Neuron.Response.html#t:t/0","title":"Neuron.Response.t/0","type":"type"},{"doc":"This module provides a simple way to interface with the process and application environmental variables, acting as a simple KV store. WARNING: this module is not intended to be used outside of this library.","ref":"Neuron.Store.html","title":"Neuron.Store","type":"module"},{"doc":"gets the context of a given neuron application/process environmental variable Examples iex&gt; Neuron.Store . current_context ( :my_key ) :global","ref":"Neuron.Store.html#current_context/1","title":"Neuron.Store.current_context/1","type":"function"},{"doc":"deletes neuron application/process environmental variables Examples iex&gt; Neuron.Store . delete ( :my_key ) :ok","ref":"Neuron.Store.html#delete/1","title":"Neuron.Store.delete/1","type":"function"},{"doc":"","ref":"Neuron.Store.html#delete/2","title":"Neuron.Store.delete/2","type":"function"},{"doc":"returns neuron application/process environmental variables Examples iex&gt; Neuron.Store . set ( :my_key , &quot;value&quot; ) :ok iex&gt; Neuron.Store . get ( :my_key ) &quot;value&quot;","ref":"Neuron.Store.html#get/1","title":"Neuron.Store.get/1","type":"function"},{"doc":"","ref":"Neuron.Store.html#get/2","title":"Neuron.Store.get/2","type":"function"},{"doc":"","ref":"Neuron.Store.html#get/3","title":"Neuron.Store.get/3","type":"function"},{"doc":"sets neuron application/process environmental variables Examples iex&gt; Neuron.Store . set ( :my_key , &quot;value&quot; ) :ok","ref":"Neuron.Store.html#set/2","title":"Neuron.Store.set/2","type":"function"},{"doc":"","ref":"Neuron.Store.html#set/3","title":"Neuron.Store.set/3","type":"function"},{"doc":"","ref":"Neuron.MissingFragmentsError.html","title":"Neuron.MissingFragmentsError","type":"exception"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Support HTTPoison 2.0 (#74) ( da19f70 ), closes #74 Bug Fixes ci(github): bump deps and switch to github actions (#72) ( c56bc74 ), closes #72","ref":"changelog.html#5-1-0-2023-02-22","title":"Changelog - 5.1.0 (2023-02-22)","type":"extras"},{"doc":"Bug Fixes neuron.connection.http: fix error case so return value matches typespec ( #60 ) ( b96d871 ), closes #59 BREAKING CHANGES neuron.connection.http: If your code expects the response field of JSONParseError to be a tuple, it will break.","ref":"changelog.html#5-0-0-2020-06-10","title":"Changelog - 5.0.0 (2020-06-10)","type":"extras"},{"doc":"Bug Fixes warning: compile time warning (default arguments in handle/3 are never used) ( 75c151c )","ref":"changelog.html#4-1-2-2020-02-19","title":"Changelog - 4.1.2 (2020-02-19)","type":"extras"},{"doc":"Bug Fixes fragments: remove duplicate fragments when inserting them into the query ( d3a5c3d ), closes #56","ref":"changelog.html#4-1-1-2019-12-26","title":"Changelog - 4.1.1 (2019-12-26)","type":"extras"},{"doc":"Features connection: Allow to inject custom connection module ( f22287e )","ref":"changelog.html#4-1-0-2019-11-21","title":"Changelog - 4.1.0 (2019-11-21)","type":"extras"},{"doc":"Bug Fixes connection: fix function signature for Neuron.Connection.post ( 82817e7 ) typespecs: Fix typespecs for Neuron.query/3 and Neuron.Store.set/3 ( 263fef4 ) Features fragment: raise Neuron.MissingFragmentsError for queries with missing fragments ( 75ddf54 ) BREAKING CHANGES fragment: Queries with missing fragments will now raise Neuron.MissingFragmentsError instead of a regular exception. Unreleased typespecs: Fix various type specs, specifically Neuron.query/2 can return a HTTPoison.Error.t().","ref":"changelog.html#4-0-0-2019-10-25","title":"Changelog - 4.0.0 (2019-10-25)","type":"extras"},{"doc":"Bug Fixes deps: Make poison a test dependency ( d75e10b )","ref":"changelog.html#3-0-1-2019-08-26","title":"Changelog - 3.0.1 (2019-08-26)","type":"extras"},{"doc":"Features json: Use Jason as default JSOn library ( 3b4e472 ) BREAKING CHANGES json: JSON parsing library is now Jason . In order to keep using Poison you'll need to manually add it as a dependency and configure neuron to use it by running Neuron.Config.set(json_library: AnotherJSONLibrary) .","ref":"changelog.html#3-0-0-2019-08-23","title":"Changelog - 3.0.0 (2019-08-23)","type":"extras"},{"doc":"chore deps: Update poison to 4.0, mock to 0.3.3 and coverex to 1.5 ( 600db92 ) BREAKING CHANGES Now requires elixir &gt;= 1.6","ref":"changelog.html#2-0-0-2019-06-26","title":"Changelog - 2.0.0 (2019-06-26)","type":"extras"},{"doc":"Features fragment: recursively embed fragments ( 3807d89 )","ref":"changelog.html#1-2-0-2019-05-30","title":"Changelog - 1.2.0 (2019-05-30)","type":"extras"},{"doc":"Bug Fixes typespecs: Fix typespec for Neuron.query/3 ( e267f8c ), closes #31","ref":"changelog.html#1-1-1-2019-03-14","title":"Changelog - 1.1.1 (2019-03-14)","type":"extras"},{"doc":"Features decode: Add support for passing options to the json decoder ( #29 ) ( f8425ac ) options: Allow to override connection options per request ( #30 ) ( 30d99e5 ) response: return a meaningful error when response is not JSON ( #27 ) ( 32004b2 )","ref":"changelog.html#1-1-0-2018-12-25","title":"Changelog - 1.1.0 (2018-12-25)","type":"extras"},{"doc":"Features query: Allow passing variables ( ff82f0a ), closes #25 BREAKING CHANGES mutation/1 and mutation/2 are deprecated query/2 is replaced by query/3 to allow passing variables in","ref":"changelog.html#1-0-0-2018-10-15","title":"Changelog - 1.0.0 (2018-10-15)","type":"extras"},{"doc":"Bug Fixes headers: Use application/json content type with :as_json ( f369555 ) 0.9.0 (2018-09-08) Features options: Allow to override options per request ( 6ba4b39 ), closes #18","ref":"changelog.html#0-9-1-2018-09-21","title":"Changelog - 0.9.1 (2018-09-21)","type":"extras"},{"doc":"Features query: Allow to send queries as json ( #20 ) ( c9689a8 ), closes #19","ref":"changelog.html#0-8-0-2018-08-22","title":"Changelog - 0.8.0 (2018-08-22)","type":"extras"},{"doc":"Features fragments: Allow to register fragments to fill queries automatically ( 5593fc6 ), closes #1","ref":"changelog.html#0-7-0-2018-07-01","title":"Changelog - 0.7.0 (2018-07-01)","type":"extras"},{"doc":"Features connection: ability to set HTTPoison connection options (#12) ( c940965 )","ref":"changelog.html#0-6-0-2018-05-15","title":"Changelog - 0.6.0 (2018-05-15)","type":"extras"},{"doc":"Docs docs(response): Adapt docs and tests to returning errors ( 495cf61 )","ref":"changelog.html#0-5-1-2018-03-13","title":"Changelog - 0.5.1 (2018-03-13)","type":"extras"},{"doc":"BREAKING CHANGE Now the value of response.body will be %{ data: ..., errors: ... } instead of %{ ... } (only returning data). fix(response): return errors alongside data ( ce2534e )","ref":"changelog.html#0-5-0-2018-03-13","title":"Changelog - 0.5.0 (2018-03-13)","type":"extras"},{"doc":"Features deps: Upgrade httpoison to version 1.0 ( 7f65a61 )","ref":"changelog.html#0-4-0-2018-02-27","title":"Changelog - 0.4.0 (2018-02-27)","type":"extras"},{"doc":"Bug Fixes deps: Relax HTTPoison dependency version ( 405e748 )","ref":"changelog.html#0-3-1-2017-09-05","title":"Changelog - 0.3.1 (2017-09-05)","type":"extras"},{"doc":"Features http: Make it possible to add custom headers ( f54a9ff ), Bug Fixes test: Update mock/meck to fix tests on elixir 1.5 ( 9768b69 )","ref":"changelog.html#0-3-0-2017-09-05","title":"Changelog - 0.3.0 (2017-09-05)","type":"extras"},{"doc":"Features config: Allow to set url globally or for current process ( 3843326 ), closes #2","ref":"changelog.html#0-2-0-2017-05-28","title":"Changelog - 0.2.0 (2017-05-28)","type":"extras"},{"doc":"Bug Fixes logging: Remove unnecessary inspect ( 6ea9240 )","ref":"changelog.html#0-1-1-2017-05-28","title":"Changelog - 0.1.1 (2017-05-28)","type":"extras"},{"doc":"Features neuron: interact with GraphQL endpoints ( version )","ref":"changelog.html#0-1-0-2017-05-28","title":"Changelog - 0.1.0 (2017-05-28)","type":"extras"},{"doc":"Copyright (c) 2017 Unai Esteibar Permission to use, copy, modify, and/or distribute this software for any purpose with or without fee is hereby granted, provided that the above copyright notice and this permission notice appear in all copies. THE SOFTWARE IS PROVIDED &quot;AS IS&quot; AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"A GraphQL client for Elixir.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Installation Usage Running Locally Contributing","ref":"readme.html#index","title":"Overview - Index","type":"extras"},{"doc":"def deps do [ { :neuron , &quot;~&gt; 5.1.0&quot; } ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Neuron defaults to using Jason for JSON encoding and decoding. To use Jason, add it to your deps: { :jason , &quot;~&gt; 1.1&quot; } It is also possible to customize which JSON library that is used: Neuron.Config . set ( json_library : AnotherJSONLibrary )","ref":"readme.html#json-library","title":"Overview - JSON library","type":"extras"},{"doc":"Neuron defaults to using HTTP(S) protocol with HTTPoison for Connecting to GraphQL endpoint. You can however customize that behaviour, by providing custom library, which should implement Neuron.Connection behaviour: defmodule MyConnection do @behaviour Neuron.Connection @impl Neuron.Connection def call ( body , options ) do IO . inspect ( &quot;NEURON CALLED&quot; ) Neuron.Connection.Http . call ( body , options ) end end Then set it up in config: Neuron.Config . set ( connection_module : MyConnection )","ref":"readme.html#connection","title":"Overview - Connection","type":"extras"},{"doc":"iex&gt; Neuron.Config . set ( url : &quot;https://example.com/graph&quot; ) iex&gt; Neuron . query ( &quot;&quot;&quot; { films { count } } &quot;&quot;&quot; ) Response will be: { :ok , % Neuron.Response { body : %{ &quot;data&quot; =&gt; %{ &quot;films&quot; =&gt; %{ &quot;count&quot; : 123 } } } , status_code : 200 , headers : [ ] } } You can also run mutations: iex&gt; Neuron . query ( &quot;&quot;&quot; mutation createUser($name: String!) { createUser(name: $name) { id name } } &quot;&quot;&quot; , %{ name : &quot;uesteibar&quot; } ) You can also set url and headers as shown below: iex&gt; Neuron . query ( &quot;&quot;&quot; mutation createUser($name: String!) { createUser(name: $name) { id name } } &quot;&quot;&quot; , %{ name : &quot;uesteibar&quot; } , url : &quot;https://example.com/graph&quot; , headers : [ authorization : &quot;Bearer &lt;token&gt;&quot; ] ) Overriding HTTP Timeout HTTPoison default timeout is 5000ms, in case we need to handle longer timeout, using default Neuron.Connection module, we could set connection_opts which will be passed to HTTPoison . So to override timeout to 15000ms, we could do: iex&gt; Neuron.Config . set ( url : &quot;https://example.com/graph&quot; , connection_opts : [ recv_timeout : 15_000 ] ) iex&gt; Neuron . query ( &quot;&quot;&quot; { films { count } } &quot;&quot;&quot; ) We can also set the timeout for a single request by passing the connection_opts to Neuron.query/3 instead: iex&gt; Neuron . query ( &quot;...&quot; , %{ } , connection_opts : [ recv_timeout : 15_000 ] ) More extensive documentation can be found at https://hexdocs.pm/neuron .","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"Clone the repository: git clone git@github.com:uesteibar/neuron.git Install dependencies: cd neuron mix deps.get To run the tests: mix test","ref":"readme.html#running-locally","title":"Overview - Running locally","type":"extras"},{"doc":"Code is formatted with mix format and mix credo should not show warnings. To format the code and run static code analysis with credo mix format mix credo","ref":"readme.html#style-guide","title":"Overview - Style guide","type":"extras"},{"doc":"Pull requests are always welcome =) The project uses standard-changelog to update the Changelog with each commit message and upgrade the package version. For that reason every contribution should have a title and body that follows the conventional commits standard conventions (e.g. feat(connection): Make it smarter than Jarvis ). To make this process easier, you can do the following: Install commitizen and cz-conventional-changelog globally: npm i -g commitizen cz-conventional-changelog Save cz-conventional-changelog as default: echo &#39;{ &quot;path&quot;: &quot;cz-conventional-changelog&quot; }&#39; &gt; ~/.czrc Instead of git commit , you can now run: git cz and follow the instructions to generate the commit message.","ref":"readme.html#contributing","title":"Overview - Contributing","type":"extras"},{"doc":"Copyright (c) 2017 Unai Esteibar This software is released under the Internet Systems Consortium License .","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]